/***************************************************************************
 *   Copyright (C) 2005 by David Santo Orcero                              *
 *   irbis@orcero.org                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DICOMIMAGE_H
#define DICOMIMAGE_H



#ifdef __cplusplus
extern "C" {
#endif



typedef struct structDICOMheadItem DICOMheadItem;

typedef DICOMheadItem *DICOMhead;

struct structDICOMheadItem
{
unsigned short group;
unsigned short element;
char vr[3];
char *longdescription;
unsigned int valuesize;
char *value;
DICOMhead next;
};


typedef struct structDICOMimage  DICOMimage;

struct structDICOMimage
{
	DICOMhead head;
	unsigned long int width;
	unsigned long int height;
	unsigned long int depth;
	unsigned long int size;
	unsigned long int mask;
	char *image;
};



int IsDCM(const char *head);
DICOMimage *renderDCMhead(char *buffer,int buffsize);
DICOMimage *loadImage(const char *filefullpath);

unsigned short int ushortbigendian(char *paux);
unsigned short int ushortlittleendian(char *paux);

#ifdef __cplusplus
}
#endif

#endif
