/***************************************************************************
 *   Copyright (C) 2005 by David Santo Orcero                              *
 *   irbis@orcero.org                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "panel2d.h"
#include <qlabel.h>
#include <qpixmap.h>
#include <qslider.h>
#include <qcanvas.h>
#include <qimage.h>
#include <kimageeffect.h>
#include <kcolorbutton.h>
#include <ktempfile.h>
#include <qcstring.h> 



Panel2D::Panel2D(QWidget *parent, const char *name)
 : Panel2DBase(parent, name)
{
	m_zoomfactor=1.5;		
	m_canvas=new QCanvas(this,"Canvas");
	m_zoom=1;		
        m_dicomimage=NULL;	
}


Panel2D::~Panel2D()
{
}


void Panel2D::updatePixmap()
{
	QString buftempname;
	KTempFile buftemp;
// ASSERT: m_pixmap can't be null.
// It begins defined.



m_canvas->setBackgroundColor(Qt::black);
m_canvas->setBackgroundPixmap(m_pixmap);


m_canvas->resize(m_pixmap.width(),m_pixmap.height());

m_dicomimageview->setCanvas(m_canvas);
//	m_dicomimageview->show();


}

void Panel2D::setDICOM(DICOMimage *dicomimage)
{
	uchar *paux;
	unsigned int x,y;
	int i;
	unsigned short actval;
	paux= (uchar*)dicomimage->image;


	
m_dicomimage=dicomimage;
m_pixmap=QImage::QImage(dicomimage->width,dicomimage->height,8,256);
for (i=0; i<256; i++ )                     // build color table
	        m_pixmap.setColor( i, qRgb(i,i,i) );

for (y=0; y<dicomimage->height; y++ ) {                 // set image pixels
	        uchar *p = m_pixmap.scanLine(y);
		        for ( x=0; x<dicomimage->width; x++ )
			{
				 
				  actval=(unsigned short) *((uchar *)(paux+1));
				  actval=actval<<8;
				  actval|=(unsigned short) *((uchar *)paux);
				  actval&=0xffff;
				  actval-=32767; // I know, it gives a warning, but this is
				  		// the safe way for this to work on non-IA32
						// platforms.
				  actval&=(dicomimage->mask);
				  actval=  ( (double)(actval*256)/(dicomimage->mask+1.5)   );

				  if(actval>255)printf("Pixel out of range:(%d)\n",actval);
				  

paux++;
paux++;
	*p=actval;
	p++;
		
			};
}
updatePixmap();
}
 

void Panel2D::zoomin()
{
	  QWMatrix wm;
	  m_zoom*=m_zoomfactor;
	  wm.scale(m_zoom,m_zoom);
	  m_dicomimageview->setWorldMatrix( wm );
}
void Panel2D::zoomout()
{
	  QWMatrix wm;
	  m_zoom=m_zoom/m_zoomfactor;
	  wm.scale(m_zoom,m_zoom);
	  m_dicomimageview->setWorldMatrix( wm );
}





	/*
void Panel2D::scale()
{


    int h = height(); //- statusBar->heightForWidth( width() ) - status->height();

    if ( m_pixmap.isNull() ) return;

    QApplication::setOverrideCursor( waitCursor ); // this might take time
    if ( width() == pm.width() && h == pm.height() )
    {                                           // no need to scale if widget
        pmScaled = pm;                          // size equals pixmap size
    } else {
        if (smooth()) {
            pmScaled.convertFromImage(m_pixmap.smoothScale(width(), h),
                conversion_flags);
        } else {
            QWMatrix m;                         // transformation matrix
            m.scale(((double)width())/pm.width(),// define scale factors
                    ((double)h)/pm.height());
            pmScaled = pm.xForm( m );           // create scaled pixmap
        }
    }
    QApplication::restoreOverrideCursor();      // restore original cursor
}
*/

/*
  The resize event handler, if a valid pixmap was loaded it will call
  scale() to fit the pixmap to the new widget size.
*/
/*
void Panel2D::resizeEvent( QResizeEvent * )
{
    status->setGeometry(0, height() - status->height(),
                        width(), status->height());

    if ( pm.size() == QSize( 0, 0 ) )           // we couldn't load the image
        return;

    int h = height() - menubar->heightForWidth( width() ) - status->height();
    if ( width() != pmScaled.width() || h != pmScaled.height())
    {                                           // if new size,
        scale();                                // scale pmScaled to window
        updateStatus();
    }
    if ( image.hasAlphaBuffer() )
        erase();
}

bool Panel2D::convertEvent( QMouseEvent* e, int& x, int& y)
{
    if ( pm.size() != QSize( 0, 0 ) ) {
        int h = height() - menubar->heightForWidth( width() ) - status->height();
        int nx = e->x() * image.width() / width();
        int ny = (e->y()-menubar->heightForWidth( width() )) * image.height() / h;
        if (nx != x || ny != y ) {
            x = nx;
            y = ny;
            updateStatus();
            return TRUE;
        }
    }
    return FALSE;
}

*/
#include "panel2d.moc"
